<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

    <title>gain &#8212; pydecha 0.3+13.g1a2fafa.dirty documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b3523f8e" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=cb25574f" />
    <script src="../../_static/documentation_options.js?v=2fb7d489"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="cosmetics" href="cosmetics.html" />
    <link rel="prev" title="cellgain" href="cellgain.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <section id="module-cmos.gain.gain_acquisition">
<span id="gain"></span><h1>gain<a class="headerlink" href="#module-cmos.gain.gain_acquisition" title="Link to this heading">¶</a></h1>
<section id="gain-acquisition-module">
<h2>gain acquisition module<a class="headerlink" href="#gain-acquisition-module" title="Link to this heading">¶</a></h2>
<table class="docutils align-default">
<tbody>
<tr class="row-odd"><td><p>Author</p></td>
<td><p>Name</p></td>
<td><p>Creation</p></td>
</tr>
<tr class="row-even"><td><p>Benoit Serra</p></td>
<td><p>gain</p></td>
<td><p>%(date)</p></td>
</tr>
</tbody>
</table>
<table class="docutils align-default">
<tbody>
<tr class="row-odd"><td><p>Contributor</p></td>
<td><p>Name</p></td>
<td><p>Creation</p></td>
</tr>
<tr class="row-even"><td><p>Name</p></td>
<td><p>filename</p></td>
<td><p>06/21/2019</p></td>
</tr>
</tbody>
</table>
<p>This is a documentation template for the gain acquisition module.
Documentation is generated going into docs/ and typing ‘make html’</p>
<p>This module can be found in pydecha/modules/gain/gain_acquisition.py.
Please modify the docstrings accordingly to provide the users a simple and
detailed explanation of your algorithm for this module.</p>
<section id="table-examples">
<h3>Table examples<a class="headerlink" href="#table-examples" title="Link to this heading">¶</a></h3>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Table entries</p></th>
<th class="head"><p>Table values</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>Entry 1</p></td>
<td><p>Value 1</p></td>
</tr>
<tr class="row-odd"><td><p>Entry 2</p></td>
<td><p>Value 2</p></td>
</tr>
<tr class="row-even"><td><p>Entry 3</p></td>
<td><p>Value 3</p></td>
</tr>
<tr class="row-odd"><td><p>Entry 4</p></td>
<td><p>Value 4</p></td>
</tr>
<tr class="row-even"><td><p>Entry 5</p></td>
<td><p>Value 5</p></td>
</tr>
</tbody>
</table>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Header row, column 1
(header rows optional)</p></th>
<th class="head"><p>Header 2</p></th>
<th class="head"><p>Header 3</p></th>
<th class="head"><p>Header 4</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>body row 1, column 1</p></td>
<td><p>column 2</p></td>
<td><p>column 3</p></td>
<td><p>column 4</p></td>
</tr>
<tr class="row-odd"><td><p>body row 2</p></td>
<td colspan="3"><p>Cells may span columns.</p></td>
</tr>
<tr class="row-even"><td><p>body row 3</p></td>
<td rowspan="2"><p>Cells may
span rows.</p></td>
<td colspan="2" rowspan="2"><ul class="simple">
<li><p>Table cells</p></li>
<li><p>contain</p></li>
<li><p>body elements.</p></li>
</ul>
</td>
</tr>
<tr class="row-odd"><td><p>body row 4</p></td>
</tr>
<tr class="row-even"><td><p>body row 5</p></td>
<td colspan="2"><p>Cells may also be
empty: <code class="docutils literal notranslate"><span class="pre">--&gt;</span></code></p></td>
<td></td>
</tr>
</tbody>
</table>
</section>
<section id="code-example">
<h3>Code example<a class="headerlink" href="#code-example" title="Link to this heading">¶</a></h3>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">sys</span>

<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Hello world...&#39;</span><span class="p">)</span>
</pre></div>
</div>
</section>
<section id="useful-links">
<h3>Useful links<a class="headerlink" href="#useful-links" title="Link to this heading">¶</a></h3>
<p>ReadTheDocs documentation
<a class="reference external" href="https://sphinx-rtd-theme.readthedocs.io/en/latest/index.html">https://sphinx-rtd-theme.readthedocs.io/en/latest/index.html</a></p>
<div class="admonition-todo admonition" id="id1">
<p class="admonition-title">Todo</p>
<p>Write the documentation for gain</p>
</div>
</section>
</section>
<dl class="py class">
<dt class="sig sig-object py" id="cmos.gain.gain_acquisition.module">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">cmos.gain.gain_acquisition.</span></span><span class="sig-name descname"><span class="pre">module</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">module_name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yaml_dict</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#cmos.gain.gain_acquisition.module" title="Link to this definition">¶</a></dt>
<dd><p>Example class with documented types</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>None</strong> – analysis module initialize with the parameters from the yaml conf. file</p>
</dd>
<dt class="field-even">Return None<span class="colon">:</span></dt>
<dd class="field-even"><p>The return value. Nothing for now…</p>
</dd>
</dl>
</dd></dl>

<section id="gain-analysis-module">
<span id="module-cmos.gain.gain_analysis"></span><h2>gain analysis module<a class="headerlink" href="#gain-analysis-module" title="Link to this heading">¶</a></h2>
<table class="docutils align-default">
<tbody>
<tr class="row-odd"><td><p>Author</p></td>
<td><p>Name</p></td>
<td><p>Creation</p></td>
</tr>
<tr class="row-even"><td><p>Benoit Serra</p></td>
<td><p>Photon Transfer Curve</p></td>
<td><p>Tue May 28 13:46:03 2019</p></td>
</tr>
</tbody>
</table>
<table class="docutils align-default">
<tbody>
<tr class="row-odd"><td><p>Contributor</p></td>
<td><p>Name</p></td>
<td><p>Creation</p></td>
</tr>
<tr class="row-even"><td><p>Domingo Alvarez</p></td>
<td><p>H4RG PTC Analysis.ipynb</p></td>
<td><p>06/21/2019</p></td>
</tr>
</tbody>
</table>
<p>This module can be found in pydecha/modules/gain/gain_analysis.py.
Please modify the docstrings accordingly to provide the users a simple and
detailed explanation of your algorithm for this module.</p>
<section id="conversion-gain">
<h3>Conversion gain<a class="headerlink" href="#conversion-gain" title="Link to this heading">¶</a></h3>
<p>The conversion gain of the detector represents the conversion rate between
number of photogenerated charges in the pixel and the number of photo-generated
carriers.</p>
</section>
<section id="photon-transfer-curve">
<h3>Photon Transfer Curve<a class="headerlink" href="#photon-transfer-curve" title="Link to this heading">¶</a></h3>
<p>The Photon Transfer Curve (PTC) is the relation between the value and the
variance of the signal. In order to measure it there are several ways:
- Keeping the LED on and take images at different DIT
- Keeping the DIT constant and taking several images with increasing the LED current
Py plotting the signal against the variance, the slope of this curve gives the
reciprocal of the Gain.</p>
</section>
<section id="data-acquisition">
<h3>Data acquisition<a class="headerlink" href="#data-acquisition" title="Link to this heading">¶</a></h3>
<p>For the same exposure time, LED values were increased. I can’t find any data
on the LED in the FITS headers. For each LED value, a 1.38s CDS was taken. The
process was repeated 102 times, creating 102 FITS files.</p>
</section>
<section id="computation">
<h3>Computation<a class="headerlink" href="#computation" title="Link to this heading">¶</a></h3>
<p>The analysis is a bit different than the typical PTC curve. For all 102 files,
we do the analysis by pair. We take both CDS images and subtract them, which
gives the signal difference between two LED values.</p>
<p>The variance of the subtraction between two CDS is then divided by two.
The average of the two CDS gives an estimation of the signal that we should have
between the two LED values.</p>
<p>Since we need a lot of samples for statistical significance of the results,
an average of several pixels is done by defining ‘boxes’ of pixels where the
spatial variance and average signal is taken to compute one point of the PTC.</p>
</section>
<section id="plots">
<h3>Plots<a class="headerlink" href="#plots" title="Link to this heading">¶</a></h3>
<section id="photon-transfer-curver">
<h4>Photon Transfer Curver<a class="headerlink" href="#photon-transfer-curver" title="Link to this heading">¶</a></h4>
<p>Plotting variance versus average gives the PTC for all the boxes. On top of it,
plotting the line going through the median value of all boxes.</p>
</section>
<section id="boxes">
<h4>Boxes<a class="headerlink" href="#boxes" title="Link to this heading">¶</a></h4>
<p>Representing the location of the boxes in the image.</p>
</section>
<section id="gain-fit">
<h4>Gain fit<a class="headerlink" href="#gain-fit" title="Link to this heading">¶</a></h4>
<p>By doing a linear fit of the median values for variance = f(signal), we can
compute the gain by extracting the slope of the fit and taking the reciprocal.</p>
</section>
</section>
<section id="analysis-block">
<h3>Analysis block<a class="headerlink" href="#analysis-block" title="Link to this heading">¶</a></h3>
</section>
</section>
<dl class="py class">
<dt class="sig sig-object py" id="cmos.gain.gain_analysis.module">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">cmos.gain.gain_analysis.</span></span><span class="sig-name descname"><span class="pre">module</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">module_name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yaml_dict</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#cmos.gain.gain_analysis.module" title="Link to this definition">¶</a></dt>
<dd><p>Gain analysis block</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>(</strong><strong>str</strong><strong>)</strong> (<em>module_name</em>) – Name of the module as string.</p></li>
<li><p><strong>(</strong><strong>dict</strong><strong>)</strong> (<em>yaml_dict</em>) – full dictionnary of the config file.</p></li>
</ul>
</dd>
<dt class="field-even">Return clean_output()<span class="colon">:</span></dt>
<dd class="field-even"><p>a cleaned dictionnary with the parameters saved</p>
</dd>
</dl>
<p>The gain analysis requires the following parameters in the configuration
file:</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>(</strong><strong>str</strong><strong>)</strong> (<em>data_path</em>) – absolute path of where the data is.</p></li>
<li><p><strong>(</strong><strong>dict</strong><strong>)</strong> (<em>fit</em>) – coordinates of the subarray where the PTC will be
computed</p></li>
<li><p><strong>(</strong><strong>dict</strong><strong>)</strong> – coordinates of the subarray where the noise will
be estimated</p></li>
<li><p><strong>(</strong><strong>int</strong><strong>)</strong> (<em>box_y</em>) – number of columns for a box</p></li>
<li><p><strong>(</strong><strong>int</strong><strong>)</strong> – number of rows for a box</p></li>
<li><p><strong>(</strong><strong>dict</strong><strong>)</strong> – fit parameters [fit_start (int), fit_stop (int)]</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</section>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">pydecha</a></h1>








<h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Introduction</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../introduction/pydecha.html">PYDECHA</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../introduction/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../introduction/first_steps.html">Getting started</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Characterization modules</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../new_module.html">Tutorial for new module</a></li>
<li class="toctree-l1"><a class="reference internal" href="../modules_ccd.html">Modules CCD</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../modules_cmos.html">Modules CMOS</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="monitoring.html">monitoring</a></li>
<li class="toctree-l2"><a class="reference internal" href="noise.html">noise</a></li>
<li class="toctree-l2"><a class="reference internal" href="preampgain.html">preampgain</a></li>
<li class="toctree-l2"><a class="reference internal" href="cellgain.html">cellgain</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">gain</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#gain-acquisition-module">gain acquisition module</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#table-examples">Table examples</a></li>
<li class="toctree-l4"><a class="reference internal" href="#code-example">Code example</a></li>
<li class="toctree-l4"><a class="reference internal" href="#useful-links">Useful links</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#cmos.gain.gain_acquisition.module"><code class="docutils literal notranslate"><span class="pre">module</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#gain-analysis-module">gain analysis module</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#conversion-gain">Conversion gain</a></li>
<li class="toctree-l4"><a class="reference internal" href="#photon-transfer-curve">Photon Transfer Curve</a></li>
<li class="toctree-l4"><a class="reference internal" href="#data-acquisition">Data acquisition</a></li>
<li class="toctree-l4"><a class="reference internal" href="#computation">Computation</a></li>
<li class="toctree-l4"><a class="reference internal" href="#plots">Plots</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#photon-transfer-curver">Photon Transfer Curver</a></li>
<li class="toctree-l5"><a class="reference internal" href="#boxes">Boxes</a></li>
<li class="toctree-l5"><a class="reference internal" href="#gain-fit">Gain fit</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="#analysis-block">Analysis block</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#cmos.gain.gain_analysis.module"><code class="docutils literal notranslate"><span class="pre">module</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="cosmetics.html">cosmetics</a></li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">About</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../about/acronyms.html">Acronyms</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../about/authors.html">Authors</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../about/changelog.html">Change log</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../about/faq.html">FAQ</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../about/license.html">License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../about/references.html">References</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../modules_cmos.html">Modules CMOS</a><ul>
      <li>Previous: <a href="cellgain.html" title="previous chapter">cellgain</a></li>
      <li>Next: <a href="cosmetics.html" title="next chapter">cosmetics</a></li>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2019, European Southern Observatory.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="../../_sources/modules/modules_cmos/gain.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>